# Test Suite

This module lets the user run PHPUnit and custom tests from the admin area of drupal. It assumes that all modules are put in contrib or custom folders in the modules folder. It provides two links. A configuration link where the admin can add variables to the phpunit.xml file and rebuild it when needed and a page that lists the Phpunit test available in core, contrib and custom folders. When tests are selected and ran a report is generated.

INSTALLATION
------------

I recommend using the [wikimedia/composer-merge-plugin](https://github.com/wikimedia/composer-merge-plugin). Read the page for installation. It works by combining composer files listed in the include section. If your modules have a composer file and require any packages it will go out, find the json file and load them. Under merge-plugin in the include section erase any other includes unless you need them. Add `modules/contrib/*/composer.json` or `web/modules/contrib/*/composer.json` depending on your path and erase the require section underneath include. Once again if its not needed. Then run composer update if you have downloaded Test Suite already or run composer require drupal/testsuite and all your dependencies should be downloaded and instaled along with Test Suite.

REQUIREMENTS
------------

A Drupal site installed via composer. You can get a drupal installation at [Drupal Downloads](https://github.com/drupal/drupal/blob/8.9.x/composer.json) that uses composer to maintain its packages.

DEBUGGING
---------

If for some reason you have the wrong require-dev packages installed or the packages needed did not load you will get errors. You can try running `composer update` in the root of your Drupal installation. Drupal 8 uses phpunit 6 an 7, Drupal 9 uses phpunit 8 and Drupal 10 and 11 uses phpunit 9. The Test Suite module will not work right if you do not use the right version of phpunit. If you have any problems or errors check the version of drupal you are using on Drupal's Status Page in the Admin Reports section. Then go to [Drupal Downloads](https://github.com/drupal/drupal/blob/8.9.x/composer.json), select the version of drupal you are using and make sure your require-dev section of Drupal's root composer.json file is using the right phpunit packages. If you need to use Drupal's root composer.json instead of Test Suites dont use the merge plugin and everthing should still work fine.

To run PHPUnit commands in Drupal you will usually need to configure the phpunit.xml file in the core directory. This module does this for you when you save the config. The most important are the domain and the database connection. Select the Drupal settings.php option to use the settings.php variables that got set when you installed drupal. Your phpunit.xml file should be made automatically. If not and you see an error copy the phpunit.xml.dist to phpunit.xml in the core folder of the installation. Then re-run your test.

DOCKER CONTAINERS
-----------------

To be able to copy the phpunit.xml.dist to phpunit.xml, edit the phpunit.xml file and make the sites\simpletest\browser_output directory you will need to add the www-data user to the www-data group using chown. You can put RUN chown -R www-data:www-data /var/www in your Dockerfile all the way at the end after drush deploy -y. There is another way to do this and that would be to use COPY in your Dockerfile and copy both the phpunit.xml file and the sites\simpletest\browser_output directory at build time but you loose the ability to update the phpunit.xml file from the admin area.

CREATING CUSTOM TESTS
---------------------

Custom tests run without PHPUnit. This is in case you want to run tests on production but do not want to load the require-dev dependencies on your production site. It works some what the same but has only the functionality you create. These tests are mainly for testing things like Microsoft translation account keys or some other thing that if in a pinch and the site is down a list of these would help in determining what the problem is.

To use custom tests copy the custom_tests module and put it in the modules\custom folder. Rename the `custom_tests.info.yml.txt` file to `custom_tests.info.yml` and enable the module. Build your tests in src\CustomTSTests directory. There are two to use as samples. Please follow the interface for best results.
